package me.topchetoeu.revengmc;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Scanner;

import me.topchetoeu.revengmc.core.MinecraftContext;
import me.topchetoeu.revengmc.search.Test;
import me.topchetoeu.revengmc.search.Tester;
import net.minecraft.data.BuiltinRegistries;
import net.minecraft.resources.ResourceLocation;

public class Searcher {
	public static void main(String[] args) throws Throwable {
		var ctx = MinecraftContext.initialize();

		
		var rootSeed = Long.parseLong(args[0]);
		var file = new Scanner(args[1].equals("-") ? new FileInputStream(args[1]) : System.in);
		var tests = new ArrayList<Test>();

		while (file.hasNextLine()) {
			var line = file.nextLine();
			var parts = line.split(" ");
			if (parts.length < 3) continue;

			var res = BuiltinRegistries.CONFIGURED_STRUCTURE_FEATURE.get(new ResourceLocation(parts[0].toLowerCase()));
			var x = Math.floorDiv(Integer.parseInt(parts[1]), 16);
			var y = Math.floorDiv(Integer.parseInt(parts[2]), 16);

			tests.add(new Test(res, x, y));
		}
		file.close();

		loop: for (var i = 0; i < 65536; i++) {
			long seed = rootSeed | ((long)i << 48l);
			try (var tester = new Tester(ctx, seed)) {
				for (var test : tests) {
					if (!test.test(tester)) continue loop;
				}
	
				System.out.println("SEED " + seed);
			}
		}

		System.exit(0);
	}
}
